<?php

// +---------------------------------------------------------------------------+
// | Glossary Plugin                                                           |
// +---------------------------------------------------------------------------+
// | admin/index.php                                                           |
// | Administration page.                                                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2004 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Alexander Schmacks - xp@schmacks.de                                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');


// Only let admin users access this page
if (!SEC_hasRights('glossary.admin')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the Glossary Admin page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display .= COM_startBlock($LANG_PL00['access_denied']);
    $display .= $LANG_PL00['access_denied_msg'];
    $display .= COM_endBlock();
    $display  = GLS_render($display, 'all');
    COM_output($display);
    exit;
}

foreach (['id', 'mode', 'lookup', 'value'] as $keyword) {
    if (isset ($_GET[$keyword])) {
        $$keyword = COM_applyFilter($_GET[$keyword]);
    }
}
foreach (['id', 'action', 'value'] as $keyword) {
    if (isset ($_POST[$keyword])) {
        $$keyword = COM_applyFilter($_POST[$keyword]);
    }
}

function showCategories() {
    return showList('category');

}
function showProjects() {
    return showList('project');
}
function showList($what) {
    global $T, $_TABLES, $LANG24, $LANG_GLS_00;
    $table1 = $_TABLES['gls_entry'];
    $table2 = $_TABLES['gls_' . $what];
    $T->set_var($what.'Legend', " List of {$LANG_GLS_00[$what]} ", true);
    $T->set_var($what.'Add', " Add a {$LANG_GLS_00[$what]} ", true);
    $SQL   = "SELECT {$what}, COUNT(*) as 'what' FROM $table1 GROUP BY {$what}";
    $rs    = DB_Query($SQL);
    $nr    = DB_numRows($rs);
    while ($nr > 0) {
        $A = DB_fetchArray($rs);
        $key = $A[$what];
        $nrOfKeywords["{$key}"] = $A['what'];
        $nr--;
    }
    $SQL   = "SELECT * FROM {$table2}";
    $rs    = DB_Query($SQL);
    $rows  = DB_numRows($rs);
    $nr    = $rows;
    while ($nr > 0) {
        $A = DB_fetchArray($rs);
        $editor    = '<span id="editor.'.$what.'.'.$A['id'].'" style="display:none"><div>';
        $editor   .= '<form action="index.php?mode=edit&lookup='.$what.'" method="post" enctype="multipart/form-data">';
        $editor   .= '<input type=hidden name="id"    value="'.$A['id'].   '" />';
        $editor   .= '<input type=text   name="value" value="'.$A['value'].'" />';
        $editor   .= '&nbsp;&nbsp;';
        $editor   .= '<input type="submit" name="action" value="save" />';
        $editor   .= '</form></div></span>';
        $edit      = '<a href="javascript:toggleVisibility(\'editor.'.$what.'.'.$A['id'].'\');">'.'edit'.'</a>'.$editor;
        $show      = '<a href="/glossary/index.php?'.$what.'='.$A['id'].'">'.'show'.'</a>';
        $delete    = '<a href="index.php?lookup='.$what.'&mode='.$LANG24[11].'&id='.$A['id'].'">'.$LANG24[11].'</a>';
        $T->set_var('id',    $A['id']);
        $T->set_var('value', $A['value']);
        $T->set_var('nr',    $nrOfKeywords["{$A['id']}"]);
        if (empty($T->get_var('nr'))) { $show = '';  $export = ''; }
        else                          { $delete = ''; }
        if ($what != 'project')       { $import = '';  $export = ''; }
        if ($rows <= 1) { $delete = ''; }
        $T->set_var('edit',   $edit);
        $T->set_var('show',   $show);
        $T->set_var('delete', $delete);
        if ( SEC_hasRights('glossary.admin')
          && $what == 'project') {
            $importer  = '<span id="import.'.$what.'.'.$A['id'].'" style="display:none"><div>';
            $importer .= '<form action="index.php?mode=import&lookup='.$what.'" method="post" enctype="multipart/form-data">';
            $importer .= '<input type="hidden" name="value" value="'.$A['value'].'" />';
            $importer .= '<input type="hidden" name="id"    value="'.$A['id'].   '" />';
            $importer .= '<input type="file" name="glossaryImport" id="glossaryImport" />';
            $importer .= '&nbsp;&nbsp;';
            $importer .= '<input type="submit" name="action" value="import" />';
            $importer .= '</form></div></span>';
            $export    = '<a href="index.php?lookup='.$what.'&mode=export&id='.$A['id'].'&value='.$A['value'].'"> export </a>';
            $import    = '<a href="javascript:toggleVisibility(\'import.'.$what.'.'.$A['id'].'\');">'.'import'.'</a>'.$importer;
            $T->set_var('export', $export);
            $T->set_var('import', $import);
        }
        $T->parse($what, 'listrow', true);
        $nr--;
    }
    $editor  = '<span id="editor.'.$what.'.'.'new'.'" style="display:none"><div>';
    $editor .= '<form action="index.php?mode=edit&lookup='.$what.'" method="post" enctype="multipart/form-data">';
    $editor .= '<input type=text name="value" />';
    $editor .= '&nbsp;&nbsp;';
    $editor .= '<input type="submit" name="action" value="new" />';
    $editor .= '</form></div></span>';
    $new     = '<a href="javascript:toggleVisibility(\'editor.'.$what.'.'.'new'.'\');">'.'Add a '.$LANG_GLS_00[$what].'</a> '.$editor;
    $T->set_var($what.'Add', $new);

}
function saveRow($lookup, $value, $id) {
    global $_TABLES;
    $table = $_TABLES['gls_' . $lookup];
    $SQL   = "UPDATE {$table} SET value = '$value' WHERE id = $id";
    $rs    = DB_Query($SQL);
}
function newRow($lookup, $value) {
    global $_TABLES;
    $table = $_TABLES['gls_' . $lookup];
    $SQL   = "INSERT INTO {$table} SET value = '$value'";
    $rs    = DB_Query($SQL);
    return DB_insertId();
}
function deleteRow($lookup, $id) {
    global $_TABLES;
    $table = $_TABLES['gls_' . $lookup];
    $SQL   = "DELETE FROM {$table} WHERE id = $id";
    $rs    = DB_Query($SQL);
}
function exportGlossary($id, $value) {
    global $_TABLES, $_USER;
    $fileName  = 'Glossary_Export_'.$_USER['uid'].'_'.$value;
    $lHeader    = 'category,abbreviation,explanation';
    $lines     = array();
    $result    = DB_query("SELECT category, abbreviation, explanation, categories.value as 'value' from {$_TABLES['gls_entry']} "
                        . "LEFT JOIN {$_TABLES['gls_category']} AS categories ON (category = categories.id) "
                        . "WHERE project = $id ");
    $nrows  = DB_numRows($result);
    for ($i = 1; $i<=$nrows; $i++) {
        $line = DB_fetchArray($result);
        $lExplanation = preg_replace('/"/', '""', $line['explanation']);
        $lines[] = '"'.$line['value'].'","'.$line['abbreviation'].'","'.$lExplanation.'"';     
    }
    header('Content-type: text/csv');
    header("Content-Disposition: attachment; filename=$fileName");
    print $lHeader."\n";
    print join("\n", $lines);
    print "";
    exit;
}
function importGlossary($id, $value) {
    global $_TABLES, $_USER;

    $countCategory = 0;
    $countLines    = 0;
    $countSkipped  = 0;
    $file = $_FILES['glossaryImport']['name'];
    if (empty($file)) {
        $file = 'unspecified';
        return '<pre>Denied. File '.$file.' ('.$_FILES['glossaryImport']['type'].')</pre>';
    } elseif ( $_FILES['glossaryImport']['type'] != "text/csv") {
        return '<pre>'.$file.' not a csv file ('.$_FILES['glossaryImport']['type'].')</pre>';
    }
    $columns = GLS_getColumnNames($_TABLES['gls_entry']);
    $T = GLS_getCategories();
    $categories = array();
    foreach ($T as $cID => $cValue) {
        $c = strtolower($cValue);
        $categories[$c] = $cID;
    }
    $lines = array();
    if (($handle = fopen($_FILES['glossaryImport']['tmp_name'], "r")) !== FALSE) {
        while (($lines[] = fgetcsv($handle, 1000, ',', '"')) !== FALSE) { }
    }
    fclose($handle);
    array_pop($lines);  // last element == FALSE !!

    $mColumns  = ['id','letter','project','owner','timestamp','last_owner','last_timestamp'];
        
    if( $lines[0] ) {
        $fColumns = $lines[0];
        foreach ($fColumns as $name ) {
            if ( !in_array($name, $columns )) {
                return '<pre>Denied. Column '.$name.' unknown ['.join(',', $columns).']</pre>';
            }
            if ( in_array($name, $mColumns )) {
                return '<pre>Denied. Column '.$name.' defaults ['.join(',', $mColumns).']</pre>';
            }
        }
        if ( !in_array('category', $fColumns)) {
            return '<pre>Denied. Column category missing ['.join(',', $fColumns).']</pre>';
        }
        if ( !in_array('abbreviation', $fColumns)) {
            return '<pre>Denied. Column abbreviation missing ['.join(',', $fColumns).']</pre>';
        }
        $lCategory = array_search('category', $fColumns);
        array_shift($lines);
        if( $lines ) {
            $query = [];
            DB_QUERY("START TRANSACTION;");
            foreach ($lines as $line) {
                if ($line) {  // warning: a line could be NULL
                    $countLines++;
                    $A = array();
                    $vCategory = $line[$lCategory];
                    $v = strtolower($vCategory);
                    if (!isset($categories[$v])) {
                        $categories[$v] = newRow('category', $vCategory);
                        $countCategory++;
                    }
                    $line[$lCategory] = $categories[$v];
                    for ($i = 0; $i<count($fColumns); $i++) {
                        if (is_numeric($fColumns[$i])) {
                            $A[$fColumns[$i]] = "{$line[$i]}";
                        } else {
                            $A[$fColumns[$i]] = "'".addslashes($line[$i])."'";
                        }
                    }

                    if (!GLS_isValidAbbreviation(substr($A['abbreviation'],1,-1))) {
                        $message .= '<pre>Term '.$A['abbreviation'].'is invalid; skipped </pre>';
                        $countSkipped++;
                    } elseif (DB_getItem($_TABLES['gls_entry'],'id',"LCASE(abbreviation) = LCASE({$A['abbreviation']}) AND project = {$id} AND category = {$A['category']} ")) {
                        $message .= '<pre>Term '.$A['abbreviation'].' is a duplicate; skipped </pre>';
                        $countSkipped++;
                    } else {
                        $pTimestamp          = date("Y-m-d H:i:s",time());
 //                     $A['id']             = GLS_getNewEntryID();
                        $lLetter             = strtoupper(substr(trim($A['abbreviation']),1,1));
                        if (is_numeric($lLetter)) {
                            $lLetter = '#';
                        }
                        $A['letter']         = "'".$lLetter."'";
                        $A['project']        = $id;
                        $A['timestamp']      = "'$pTimestamp'";
                        $A['last_timestamp'] = "'$pTimestamp'";
                        $A['owner']          = $_USER['uid'];
                        $A['last_owner']     = $_USER['uid'];
                        $sql  = 'INSERT INTO ' . $_TABLES['gls_entry'] .' ' ;
                        $sql .= '('. join(',', array_keys($A)). ') ';            
                        $sql .= 'VALUES ('. join(',', array_values($A)). ')';
                        if (DB_Query($sql .';', 1)) {
                        } else {
                           $message .= "<pre>{$sql}\nFailed; skipped </pre>";
                           $countSkipped++;
                        }
                    }
                }
            }
            if ($countSkipped == 0) {
                DB_Query("COMMIT;");
                $message .= '<pre>Succes; commit fired</pre>';
            } else {
                DB_Query('ROLLBACK;');
                $message .= '<pre>Failed; rollback fired</pre>';
            }
        }
    }
    if ( file_exists($_FILES['glossaryImport']['tmp_name']) ) {
        if ( unlink($_FILES['glossaryImport']['tmp_name']) ) {
            if ($countCategory > 0) {
                $s  = 'with '.$countCategory.' new categories ';
            }
            if ($countLines != count($lines)) {
                $s .= 'from '.$countLines.' lines ';
            }
            if ($countSkipped > 0) {
                $s .= 'but '.$countSkipped.' skipped ';
            }
            return '<pre>'.$countLines.' terms found '.$s.'</pre>'.$message;
        }
        return '<pre>Possible attack. File not deleted.</pre>'.$message;
    }
    return '<pre>File '.$file.' seems to be empty</pre>'.$message;
}

/**
* Main 
*/
$T = new Template($_CONF['path'] . 'plugins/glossary/templates');
$T->set_file('admin', 'admin.thtml');
$T->set_var('site_url',$_CONF['site_url']);
$T->set_var('site_admin_url', $_CONF['site_admin_url']);
$T->set_var('header', $LANG_GLS_00['admin']);
$T->set_var('plugin','glossary');
// put your code here
switch ($mode) {
    case 'edit' :
        if (!empty($lookup)) {
            switch ($action) {
                case 'save' :
                    saveRow($lookup, $value, $id);
                    break;
                case 'new'  :
                    newRow($lookup, $value);
                    break;
                default     :
                    $message = '<pre>Nothing Reached for '.$action.'</pre>';
                    break;
            }
        }
    case ''     :
    case 'list' :
        $T->set_block('admin', 'listrow');
        showCategories();
        showProjects();
        break;
    case 'delete':
        deleteRow($lookup, $id);
        $T->set_block('admin', 'listrow');
        showCategories();
        showProjects();
        break;
    case 'export':
        if ($lookup == 'project') {
            $message = exportGlossary($id, $value);
        }
        $T->set_block('admin', 'listrow');
        showCategories();
        showProjects();
        break;
    case 'import':
        if ($lookup == 'project') {
            $message = importGlossary($id, $value);
        }
        $T->set_block('admin', 'listrow');
        showCategories();
        showProjects();
        break;
    default     :
        $display .= '<pre>Nothing Here for '.$mode.'</pre>';
        break;
}
if (!empty($message)) {
    $message = '<div style="border:1px solid Blue; color: Red" align="center">'.$message.'</div>';
}
$T->set_var('message', $message);
$T->parse('output','admin');
$display .= $T->finish($T->get_var('output'));
$display  = GLS_render($display, 'all');

COM_output($display);
?>