<?php
//
// +---------------------------------------------------------------------------+
// | Glossary Plugin for Geeklog - The Ultimate Weblog                         |
// +---------------------------------------------------------------------------+
// | config.php                                                                |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003/4 by the following authors:                            |
// | Alexander Schmacks          -    alexander@schmacks.de                    |
// | Copyright (C) 2021 by the following authors:                              |
// | Remy Kobolski               -    remy@nlbox.com                           |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

// Shall the glossary be viewable by everyone (even anonymous)?
$_GLS_CONF['show_to_anyone']    = true;
$_GLS_CONF['hide_whatsnew']     = 'no';     // or 'hide'
$_GLS_CONF['whatsnew_interval'] = 1209600;  // in seconds
$_GLS_CONF['allowed_tags']      = ['<dl>','<dt>','<dd>','<ul>','<ol>','<li>','<pre>','<div>','<code>','<blockquote>'];
/**
 * D I S P L A Y --------------------------------------------------------------
 */
// Want to see right blocks? Set value to 1 !
$_GLS_CONF['right_blocks'] = 1;
// Waiting time for submit or delete pages until view gets refreshed to index page
$_GLS_CONF['refresh_time'] = 3;
// Number of glossary entries per overview page
$_GLS_CONF['limitentries'] = 10;
// Number of glossary terms in the menu
$_GLS_CONF['limitterms']   = 12;
// Number of glossary entries allowed before switching to short listings
$_GLS_CONF['threshold']    = 3;
// Number of characters to show in the popups
$_GLS_CONF['max_characters'] = 120;
// Shall links to other entries be generated with an extra icon?
$_GLS_CONF['link_with_icon'] = false;
// Replace used autotag with a hint
// $_GLS_CONF['comment']     = '%s glossary is used';
$_GLS_CONF['comment']        = '';


/**
 * D A T A / D A T A B A S E --------------------------------------------------
 */
// Set plugin table prefix
$_GLS_table_prefix = $_DB_table_prefix . 'glossary_';

// Add Glossary Plugin tables to $_TABLES array, with according prefix
$_TABLES['gls_entry']      = $_GLS_table_prefix . 'entry';
$_TABLES['gls_category']   = $_GLS_table_prefix . 'category';
$_TABLES['gls_project']    = $_GLS_table_prefix . 'project';

// Array of characters for menu selection
$_GLS_CHARACTERS = '#ABCDEFGHIJKLMNOPQRSTUVWXYZ';
?>
